# --------------------------------------------------------------------
# File SWAPDEMO.MAK
# Makefile for memory swap demo program.
#
# Copyright (C) 1994, Brian Sawert.
# All rights reserved.
#
# Notes:
#	Compatible with PolyMake.
#	Set d=y on command line to invoke debugging info.
# --------------------------------------------------------------------

INCPATH = c:\bc\include
LIBPATH	= c:\bc\lib

.PATH.obj = .\obj

.REMAKE

CL = bcc				# C compiler
ASM = tasm				# assembler
LINK = tlink				# linker
MODEL = s				# model size

# --------------------------------------------------------------------

%if "$(d)" != ""			# build a debug version
CFLAGS= -c -f- -k -N -m$(MODEL) -I$(INCPATH) -L$(LIBPATH) -v
AFLAGS= /mx /zi /DDEBUG
LFLAGS= /c /m /v
%else					# build a normal version
CFLAGS= -c -f- -k -N -m$(MODEL) -I$(INCPATH) -L$(LIBPATH)
AFLAGS= /mx
LFLAGS= /c
%endif

# --------------------------------------------------------------------

PROGNAME = swapdemo
MODULES = memswap swapdemo

# --------------------------------------------------------------------

OMODULES = $[f,,$(MODULES),obj]


# implicit rules

.c.obj :
	%if !%dir($(.PATH.obj))
		mkdir $(.PATH.obj)
	%endif
	-$(CL) $(CFLAGS) -o$@ $<
	%if %status > 0
		%exit %status
	%endif

.asm.obj :
	%if !%dir($(.PATH.obj))
		mkdir $(.PATH.obj)
	%endif
	-$(ASM) $(AFLAGS) $<, $@ 
	%if %status > 0
		%exit %status
	%endif


# implicit dependencies

$(PROGNAME).exe:  $(OMODULES) $(MAKEFILE)
	-$(LINK) $(LFLAGS) <@<
	$(LIBPATH)\c0$(MODEL).obj +
	$[s," +\n",$[f,$(.PATH.obj),$(OMODULES),obj]]
	$@
	$*.map
	c$(MODEL).lib
<


# explicit dependencies

memswap.obj:	memswap.asm
swapdemo.obj:	swapdemo.c

