// w_attr.h - definitions for useful Windows attributes
// Copyright (c) 1994 by Ron Burk

#include "wuierror.h"
#include "w_attr.h"

const TWuiName  C_TATTRIBUTECOLOR("p_Color");
//#define  C_TATTRIBUTECOLOR "p_Color"


AWuiObject *TWuiAttributeColor::ClassConstructor(const TWuiName Name)
    {
    return new TWuiAttributeColor("p_Color");
    }

TWuiAttributeColor::TWuiAttributeColor(const TWuiName ObjectName)
    :   TWuiLongProperty(ObjectName)
    {   MEMBERASSERT();
    }

AWuiObject  *TWuiAttributeColor::New(const TWuiName Name)
    {   MEMBERASSERT();
    return new TWuiAttributeColor(Name);
    }

TWuiName    TWuiAttributeColor::ClassName() const
    {   MEMBERASSERT();
    return C_TATTRIBUTECOLOR;
    }

TWuiName    TWuiAttributeColor::ParentClassName() const
    {   MEMBERASSERT();
    return TWuiLongProperty::ClassName();
    }

int     TWuiAttributeColor::IsA(const TWuiName Class,
                                      const TWuiName Method)
    {   MEMBERASSERT();
    if(Class == C_TATTRIBUTECOLOR)
        {
        if(Method == "")
            return TRUE;
        else if(GetAttribute(Method) != NULL)
            return TRUE;
        else
            return FALSE;
        }
    else
        return TWuiLongProperty::IsA(Class, Method);
    }


long    TWuiAttributeColor::Set(TWuiPath Path, TWuiArgs *Args,
                                          const char *Value)
    {   MEMBERASSERT();
    if(AWuiObject::TraceFlag)
        Trace("TWuiAttributeColor::Set", Path, Args);
    if(Args && Args->AttributeName() != Name())
        return TWuiLongProperty::Set(Path, Args, Value); 
    char   *End;
    long    Number = strtol(Value, &End, 0);
    if(End == Value || *End != '\0')
        {
        DEBUG_ERROR("Not a legal value for a color"
                " attribute: '%s'", Value);
        return WUIMAN_ERR_SET_BAD_INTEGRAL;
        }
    if(Number & 0xFF000000L)
        {
        DEBUG_ERROR("Not a legal color value: '%s'", Value);
        return WUIMAN_ERR_SET_BAD_INTEGRAL;
        }

    return TWuiLongProperty::Set(Path, Args, Value); 
    }


